# Contribution Guidelines

Thanks for your interest in contributing to this project! Here are a few guidelines that will help accelerate your
process.

## What are good things to contribute?

Since this project is still in it's early stages, we recommend all contributors report bugs and problems they may
find. Later, we will consider letting contributors suggest new features and add them.

## Steps to contribute

1. Create an issue detailing what you want to accomplish
    1. Follow the templates provided!
    2. Be sure to also highlight if you intend to also write code to implement your request or if you are simply raising
       awareness for an issue or feature.
2. Fork this repo and make your changes
3. Make a pull request, referencing the issue you made in step #1 (use the "fixes" or "closes" keywords to link your
   issue to the PR)
4. We will review and merge the PR if they meet our standards!

## Where can I find documentation for how to contribute

- The code is heavily documented with docstrings
- The
  official [Virtual Brain Lab documentation website](https://virtualbrainlab.org/build/html/05_misc/03_ephys_manip_link.html)

## Code of Conduct

If you have any questions or concerns, take a look at this repo's Code of Conduct, and don't hesitate to reach out to
us!